<script lang="ts">
import type {
  Onset, Pixel, Point, Unit,
} from '@/data';
import type { ScrollTo } from '@/logic/ScrollActions';
import { Component, Prop } from 'vue-property-decorator';
import LabelBehavior from '../LabelBehavior.vue';

@Component
export default class BScrollOnKey extends LabelBehavior {
  @Prop()
  scrollTo!: ScrollTo;

  @Prop()
  currentPosition!: Pixel;

  @Prop()
  pixelUnit!: Unit<Pixel>;

  onKey(e: KeyboardEvent) {
    if (e.key === 'ArrowLeft') {
      e.preventDefault();
      const offset = e.altKey ? 1 : 4;
      const currentOnset = this.pixelUnit.toOnset(this.currentPosition).value;
      this.scrollTo({
        x: this.pixelUnit.fromOnset(currentOnset - offset as Onset).value,
        y: 0,
      } as Point);
    }
    if (e.key === 'ArrowRight') {
      e.preventDefault();
      const offset = e.altKey ? 1 : 4;
      const currentOnset = this.pixelUnit.toOnset(this.currentPosition).value;
      this.scrollTo({
        x: this.pixelUnit.fromOnset(currentOnset + offset as Onset).value,
        y: 0,
      } as Point);
    }
  }

  mounted() {
    this.register('document-keydown', this.onKey);
    this.register('document-alt-keydown', this.onKey);
  }
}
</script>
